<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="text" />

  <!-- 
  This is the main body of the class
  -->
  <xsl:template match ="/Class">
    public class <xsl:value-of select ="@name"/> {
    <xsl:apply-templates select="Aspects/*" />

    public <xsl:value-of select ="@name"/>() {
    <xsl:apply-templates select="Subscriptions/Subscription"/>
    <xsl:apply-templates select ="Delegates/Delegate"/>
    }
    }
  </xsl:template>

  <!-- 
  each aspect provides its own code snippet
  in practice the code only consists of a field declaration
  the actual code is placed in a separate aspect class 
   -->

  <xsl:template match="Identifier">
    public Identifier <xsl:value-of select="@name"/> =
    new Identifier("<xsl:value-of select="../../@name" /><xsl:value-of select="@name"/>Sequence",
    <xsl:value-of select="@seed"/>,
    <xsl:value-of select ="@step"/>
    );
  </xsl:template>

  <xsl:template match="Description">
    public Description <xsl:value-of select="@name"/> = new Description();
  </xsl:template>

  <xsl:template match="DueDate">
    public DueDate <xsl:value-of select="@name"/> = new DueDate(<xsl:value-of select="@days"/>);
  </xsl:template>

  <xsl:template match="Notification">
    public Notification <xsl:value-of select="@name"/> = new Notification();
  </xsl:template>

  <!-- 
  the Map section provides the weaving between event sources and event targets
  -->
  <xsl:template match ="Subscription">
    <xsl:value-of select ="@source"/>.<xsl:value-of select ="@sourceevent"/> += <xsl:value-of select ="@target"/>.<xsl:value-of select ="@targetevent"/>;
  </xsl:template>

  <xsl:template match="Delegate">
    <xsl:value-of select="@target"/>.<xsl:value-of select="@property"/> += delegate {
    <xsl:value-of select ="text()"/>;
    };
  </xsl:template>
</xsl:stylesheet>