﻿//Copyright (C) 2007 Christian Scheller

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ApplicationModel;
using System.Reflection;
using AspectTypes;

namespace Controls {
    public partial class Form1 : Form {

        public Form1() {
            InitializeComponent();
        }

        private void button2_Click(object sender, EventArgs e) {
            Task task = new Task();
            listBox1.Items.Add(task);
            listBox1.SelectedItem = task;
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e) {
            this.panel1.Visible = false;
            object obj = listBox1.SelectedItem;
            panel1.Controls.Clear();
            foreach (FieldInfo fieldInfo in typeof(Task).GetFields()) {
                AspectControl control = null;
                switch (fieldInfo.FieldType.Name) {
                    case "Description": {
                            control = new DescriptionControl();
                            break;
                        }
                    case "Identifier": {
                            control = new IdentifierControl();
                            break;
                        }
                    case "DueDate": {
                            control = new DueDateControl();
                            break;
                        }
                    case "Notification": {
                            control = new NotificationControl();
                            break;
                        }
                    default: {
                            continue;
                        }
                }
                panel1.Controls.Add(control);
                control.Dock = DockStyle.Top;
                control.BringToFront();
                control.Initialize(fieldInfo.GetValue(obj), fieldInfo.Name);
            }
            this.panel1.Visible = true;
        }

        private void button3_Click(object sender, EventArgs e) {
            DueDate.Check(DateTime.Now);
        }
    }
}