﻿//Copyright (C) 2007 Christian Scheller

using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using ApplicationModel;
using AspectTypes;

namespace Storage {

    public class TaskFacade {
        public static List<Task> GetAll(SqlConnection connection) {
            List<Task> result = new List<Task>();
            SqlCommand command = connection.CreateCommand();
            command.CommandText = @"select ID, Text, DeadlineDate, DeadlineState, Notify from Task";
            using (SqlDataReader reader = command.ExecuteReader()) {
                while (reader.Read()) {
                    Task item = new Task();
                    item.ID.Value = (int)reader["ID"];
                    item.Text.Value = (string)reader["Text"];
                    item.Deadline.Date = (DateTime)reader["DeadlineDate"];
                    item.Deadline.State = (DueDate.States)reader["DeadlineState"];
                    item.Notify.EMailAddress = (string)reader["Notify"];
                    result.Add(item);
                }
            }
            return result;
        }

        public static void Insert(Task item, SqlConnection connection) {
            SqlCommand command = connection.CreateCommand();
            command.CommandText = @"insert into Task (ID, Text, DeadlineDate, DeadlineState, Notify) values (@ID, @Text, @DeadlineDate, @DeadlineState, @Notify)";
            command.Parameters.AddWithValue("@ID", item.ID.Value);
            command.Parameters.AddWithValue("@Text", item.Text.Value);
            command.Parameters.AddWithValue("@Deadlinedate", item.Deadline.Date);
            command.Parameters.AddWithValue("@Deadlinestate", item.Deadline.State);
            command.Parameters.AddWithValue("@Notify", item.Notify.EMailAddress);
            command.ExecuteNonQuery();
        }
    }
}
